import { Resource, ResourceProps } from 'aws-cdk-lib';
import { CfnIPAMAllocation } from 'aws-cdk-lib/aws-ec2';
import { IConstruct } from 'constructs';
import { IIpamPool } from './ipam-pool';
export interface ResolvedIpamAllocationConfiguration {
    readonly cidr?: string;
    readonly netmaskLength?: number;
}
export interface IIpamAllocationConfiguration {
    bind(scope: IConstruct): ResolvedIpamAllocationConfiguration;
}
export declare class IpamAllocationConfiguration {
    static auto(): IIpamAllocationConfiguration;
    static cidr(cidr: string): IIpamAllocationConfiguration;
    static netmask(length: number): IIpamAllocationConfiguration;
}
export interface IIpamAllocation {
    readonly ipamAllocationCidr: string;
    readonly ipamAllocationId: string;
}
declare abstract class IpamAllocationBase extends Resource implements IIpamAllocation {
    abstract readonly ipamAllocationCidr: string;
    abstract readonly ipamAllocationId: string;
}
export interface IpamAllocationOptions {
    readonly allocation?: IIpamAllocationConfiguration;
    readonly description?: string;
}
export interface IpamAllocationProps extends ResourceProps, IpamAllocationOptions {
    readonly ipamPool: IIpamPool;
}
export declare class IpamAllocation extends IpamAllocationBase {
    readonly allocation: IIpamAllocationConfiguration;
    readonly description?: string;
    readonly ipamPool: IIpamPool;
    readonly resource: CfnIPAMAllocation;
    readonly ipamAllocationCidr: string;
    readonly ipamAllocationId: string;
    constructor(scope: IConstruct, id: string, props: IpamAllocationProps);
}
export {};
