import { AllocateCidrRequest, IIpAddresses, SubnetIpamOptions, VpcIpamOptions } from 'aws-cdk-lib/aws-ec2';
import { IIpamPool } from '../..';
import { IIpv4CidrAssignment } from '../cidr-assignment';
export interface TieredSubnetsOptions {
    readonly provider: IIpv4CidrAssignment;
    readonly tierMask?: number;
}
export declare class TieredSubnets implements IIpAddresses {
    readonly ipamOptions: VpcIpamOptions;
    readonly ipamPool?: IIpamPool;
    readonly netmask: number;
    readonly tierMask?: number;
    constructor(options: TieredSubnetsOptions);
    allocateVpcCidr(): VpcIpamOptions;
    allocateSubnetsCidr(input: AllocateCidrRequest): SubnetIpamOptions;
    private allocateSubnetsCidrIpam;
    private allocateSubnetsCidrNoIpam;
}
