import { Resource, ResourceProps } from 'aws-cdk-lib';
import { CfnSite } from 'aws-cdk-lib/aws-networkmanager';
import { IConstruct } from 'constructs';
import { IGlobalNetwork } from './global-network';
export interface ISite {
    readonly siteArn: string;
    readonly siteId: string;
}
export interface SiteProps extends ResourceProps {
    readonly address?: string;
    readonly description?: string;
    readonly latitude?: string;
    readonly longitude?: string;
    readonly globalNetwork: IGlobalNetwork;
}
declare abstract class SiteBase extends Resource implements ISite {
    abstract readonly siteArn: string;
    abstract readonly siteId: string;
}
export declare class Site extends SiteBase {
    readonly address?: string;
    readonly description?: string;
    readonly latitude?: string;
    readonly longitude?: string;
    readonly globalNetwork: IGlobalNetwork;
    readonly resource?: CfnSite;
    readonly siteArn: string;
    readonly siteId: string;
    constructor(scope: IConstruct, id: string, props: SiteProps);
}
export {};
