import { IResolvable, Resource, ResourceProps } from 'aws-cdk-lib';
import { Connections, IConnectable, ISecurityGroup, IVpc, SubnetSelection } from 'aws-cdk-lib/aws-ec2';
import { CfnDBProxyEndpoint, IDatabaseProxy } from 'aws-cdk-lib/aws-rds';
import { Construct } from 'constructs';
export declare class DatabaseProxyEndpointAccess {
    readonly role: string;
    static readonly READ_ONLY: DatabaseProxyEndpointAccess;
    static readonly READ_WRITE: DatabaseProxyEndpointAccess;
    static of(role: string): DatabaseProxyEndpointAccess;
    private constructor();
}
export interface DatabaseProxyEndpointProps extends ResourceProps {
    readonly access?: DatabaseProxyEndpointAccess;
    readonly databaseProxy: IDatabaseProxy;
    readonly name?: string;
    readonly securityGroups?: ISecurityGroup[];
    readonly vpc: IVpc;
    readonly vpcSubnets?: SubnetSelection;
}
export declare class DatabaseProxyEndpoint extends Resource implements IConnectable {
    readonly access?: DatabaseProxyEndpointAccess;
    readonly databaseProxy: IDatabaseProxy;
    readonly name?: string;
    readonly vpc: IVpc;
    readonly vpcSubnets: SubnetSelection;
    readonly resource: CfnDBProxyEndpoint;
    readonly databaseProxyEndpointArn: string;
    readonly databaseProxyEndpointHost: string;
    readonly databaseProxyEndpointIsDefault: IResolvable;
    readonly databaseProxyEndpointVpcId: string;
    readonly connections: Connections;
    constructor(scope: Construct, id: string, props: DatabaseProxyEndpointProps);
}
