import { ArnFormat, Resource, ResourceProps } from 'aws-cdk-lib';
import { CfnGroup } from 'aws-cdk-lib/aws-resourcegroups';
import { IConstruct } from 'constructs';
import { IGroupConfiguration } from './lib/configuration-ref';
export interface IGroup {
    readonly groupArn: string;
    readonly groupName: string;
}
declare abstract class GroupBase extends Resource implements IGroup {
    abstract readonly groupArn: string;
    abstract readonly groupName: string;
    constructor(scope: IConstruct, id: string, props?: ResourceProps);
}
export interface GroupAttributes {
    readonly arn?: string;
    readonly name?: string;
}
export interface GroupProps extends ResourceProps {
    readonly configuration: IGroupConfiguration;
    readonly description?: string;
    readonly name?: string;
}
export declare class Group extends GroupBase {
    static readonly ARN_FORMAT: ArnFormat;
    static fromGroupArn(scope: IConstruct, id: string, arn: string): IGroup;
    static fromGroupAttributes(scope: IConstruct, id: string, attrs: GroupAttributes): IGroup;
    static fromGroupName(scope: IConstruct, id: string, name: string): IGroup;
    readonly description?: string;
    readonly name: string;
    readonly resource: CfnGroup;
    readonly groupArn: string;
    readonly groupName: string;
    constructor(scope: IConstruct, id: string, props: GroupProps);
}
export {};
